﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;

namespace AppDomainLoadUnloadEx2
{
    class Program
    {
        static void Main(string[] args)
        {
            SeparateAppDomainAssemblyLoader appDomainAssemblyLoader = new SeparateAppDomainAssemblyLoader();

            List<FileInfo> assemblies = new List<FileInfo>();
            string root = @"C:\windows\temp\";

            assemblies.Add(new FileInfo(root + @"PortableRandomAdder.dll"));
            assemblies.Add(new FileInfo(root + @"PortableRandomAdderCopy.dll"));

            Console.WriteLine();
            Console.WriteLine("Loading assemblies to parent AppDomain ...");

            foreach (FileInfo assemblyLocation in assemblies)
            {
                System.Diagnostics.Debug.WriteLine(assemblyLocation.FullName);
                Assembly.LoadFrom(assemblyLocation.FullName);
            }

            foreach (Assembly hostedAssembly in AppDomain.CurrentDomain.GetAssemblies())
            {
                foreach (Type type in hostedAssembly.GetTypes())
                {
                    if ((type.Namespace != null) && (type.Namespace.StartsWith("PortableRandomAdder")))
                    {
                        Console.WriteLine("Namespace found: {0}", hostedAssembly.GetName().Name + ": " + type.FullName);
                    }
                }
            }

            Console.WriteLine();
            Console.WriteLine("Loading assemblies to child AppDomain ...");

            foreach (String @namespace in appDomainAssemblyLoader.LoadAssemblies(assemblies, "PortableRandomAdder"))
            {
                Console.WriteLine("Namespace found : {0}", @namespace);
            }

            Console.WriteLine();
            Console.WriteLine("Press any key to close ...");
            Console.ReadLine();

        }
    }
}
